
:- [inp_parse]. 
:- [lowlevel].
:- [unfold].
:- [fold].
:- [delete].
:- [cond_fold].
:- [replace].
:- mc(axiom, [spec_off]).
:- [axiom].
%:- [bound].
:- [strategy].

:- import length/2 from basics.
:- dynamic history/3.

:- start.

start :- nl, writeln('Enter the program file name'),
	 nl, read(Pgm), nl, 
	 retractall(pgm_clause(_,_,_)),
	 retractall(clauseI(_,_,_)),
	 retractall(clause0(_,_,_)),
	 cd('../Examples'),
         format(Pgm),
         cd('../Code'),
         write_pgm, reset(preds),
	 reset(unf_cnt), reset(deduce_cnt).  % reset some registers.

/* DEAD CODE 

format_pgm :- ( pgm_clause(N, (H :- B), Annot),
	        commaConvert(B, Bd),
                assert(clauseI(N, (H :- Bd), Annot)),
	        assert(clause0(N, (H :- Bd), Annot)), fail
                ; true
              ).

*/

% write_all : writes all clauses of the current program

write_pgm :- nl, writeln('BEGINNING of PROGRAM'), fail.

write_pgm :- clauseI(N, (H :- B), A),
	     vanillaConvert(B, Bd),
	     always_write_clause(N, (H :- Bd), A), fail.

write_pgm :- nl, writeln('END of PROGRAM'), nl.


write_separator :-
	write_star(32), nl.

write_star(0) :- nl.
write_star(N) :- integer(N), N> 0, !, write('*'), 
		 M is N -1, write_star(M).

write_line(0) :- nl.
write_line(N) :- write('-'), M is N -1, write_line(M).

% write_all(H) : write all clauses of H in current program

write_all(H) :- clauseI(N, (H :- B), A),
	        vanillaConvert(B, Bd),
		write_clause(N, (H :- Bd), A), fail.
write_all(_).

% write_all(P, N) : write all clauses of P/N 

write_all(P, N) :- length(L, N), H =.. [P|L], write_all(H).

write_clause(N, (H :- B), A) :-
	nl, write(N), write(' '), 
	vanillaConvert(B, Bd), 
        write((H :- Bd)), write(' '), 
        writeln(A).

write_clause(N) :- 
	clauseI(N, (H :- B), A),
	vanillaConvert(B, Bd), nl, 
        write(N), write(' '), 
        write((H :- Bd)), 
        write(' '), writeln(A).

write_clauses([]).
write_clauses([H|T]) :- write_clause(H), write_clauses(T).

%---------------------------------------------------------------
% Writing in the user mode 
% Write without looking at user flag

always_write_clause(N, (H :- B), A) :-
	nl, write(N), write(' '), 
	vanillaConvert(B, Bd), 
        write((H :- Bd)), write(' '), 
        writeln(A).
        
always_write_clause(N) :- 
	clauseI(N, (H :- B), A),
	vanillaConvert(B, Bd), nl, 
        write(N), write(' '), 
        write((H :- Bd)), 
        write(' '), writeln(A).

always_write_clauses([]).
always_write_clauses([H|T]) :- always_write_clause(H), 
		               always_write_clauses(T).
%---------------------------------------------------------------------

assert_clause(N, C, A) :-
	C = (H :- B),
	commaConvert(B, Bd),
	assert(clauseI(N, (H :- Bd), A)).

assert_def(N, C, A) :-
	C = (H :- B),
	commaConvert(B, Bd),
	assert(clauseI(N, (H :- Bd), A)),
	assert(clause0(N, (H :- Bd), A)).

%-------------------------------------------------------
% Setting the parameters 

setMaxDepth(N) :- 
	( integer(N), N > 0 -> retractall(maxDepthConstant(_)),
			       assert(maxDepthConstant(N))
		            ;  write('ERROR : Cannot set max depth to '),
			       writeln(N), fail
        ).
