subsumes(T1, T2, Inst) :-
	copy_term(T1, T1d, V1),
	copy_term(T2, T2d, V2), 
        subsumes(T1d, T2d),
	append(V1, V2, Vmap),
	get_subst(Vmap, Inst).

copy_term(X, Y, Vmap) :-
	copy_term(X, Y), 
	get_vmap(X, Y, Vmap0),
	var_remove_dupl(Vmap0, Vmap).

get_vmap(X, Y, [(X, Y)]) :- var(X), var(Y), !.
get_vmap(X, Y, L) :- X =.. [P|Args], Y =.. [P|Args1],
  		     get_vmap_list(Args, Args1, L).

get_vmap_list([], [], []).
get_vmap_list([H|T], [H1|T1], Res) :-
	get_vmap(H, H1, L1),
	get_vmap_list(T, T1, L2), append(L1, L2, Res).

get_subst(Vmap, Inst) :- get_subst(Vmap, Vmap, Inst1),
		         filter_ident(Inst1, Inst).

filter_ident([], []).
filter_ident([(X,Y)|T], R) :-
	filter_ident(T, R1), 
	(X == Y -> R = R1 ; R = [(X,Y)|R1]).

get_subst([], _, []).
get_subst([(X,Y)|Rest], Vmap, [(X,T)|Irest]) :-
	get_subst_one(Y, Vmap, T),
	get_subst(Rest, Vmap, Irest).
	

get_subst_one(Y, Vmap, X) :- var(Y), !, vmap_memY((X, Y), Vmap).
get_subst_one(Y, Vmap, X) :- 
	Y =.. [P|Args],
        get_subst_one_list(Args, Vmap, Args1),	
        X =.. [P|Args1].

get_subst_one_list([], _, []).
get_subst_one_list([H|T], Vmap, [H1|T1]) :-
	get_subst_one(H, Vmap, H1),
	get_subst_one_list(T, Vmap, T1).
	
% Given X, find Y using the variable map/subst

vmap_memX((X, Y), [(Z, W)|T]) :- 
	X == Z -> Y = W ; vmap_memX((X, Y), T).
	
% Given Y, find X using the variable map/subst

vmap_memY((X, Y), [(Z, W)|T]) :- 
	Y == W -> X = Z ; vmap_memY((X, Y), T).
